package cn.ibizlab.eam.core.eam_core.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.eam.core.eam_core.domain.EMEQSetup;
import cn.ibizlab.eam.core.eam_core.filter.EMEQSetupSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface EMEQSetupMapper extends BaseMapper<EMEQSetup>{

    Page<EMEQSetup> searchDefault(IPage page, @Param("srf") EMEQSetupSearchContext context, @Param("ew") Wrapper<EMEQSetup> wrapper) ;
    @Override
    EMEQSetup selectById(Serializable id);
    @Override
    int insert(EMEQSetup entity);
    @Override
    int updateById(@Param(Constants.ENTITY) EMEQSetup entity);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<EMEQSetup> selectByAcclassid(@Param("emacclassid") Serializable emacclassid) ;

    List<EMEQSetup> selectByEitiresid(@Param("emeitiresid") Serializable emeitiresid) ;

    List<EMEQSetup> selectByEquipid(@Param("emequipid") Serializable emequipid) ;

    List<EMEQSetup> selectByObjid(@Param("emobjectid") Serializable emobjectid) ;

    List<EMEQSetup> selectByRfoacid(@Param("emrfoacid") Serializable emrfoacid) ;

    List<EMEQSetup> selectByRfocaid(@Param("emrfocaid") Serializable emrfocaid) ;

    List<EMEQSetup> selectByRfodeid(@Param("emrfodeid") Serializable emrfodeid) ;

    List<EMEQSetup> selectByRfomoid(@Param("emrfomoid") Serializable emrfomoid) ;

    List<EMEQSetup> selectByRserviceid(@Param("emserviceid") Serializable emserviceid) ;

    List<EMEQSetup> selectByWoid(@Param("emwoid") Serializable emwoid) ;

    List<EMEQSetup> selectByRdeptid(@Param("pfdeptid") Serializable pfdeptid) ;

    List<EMEQSetup> selectByRempid(@Param("pfempid") Serializable pfempid) ;

    List<EMEQSetup> selectByRteamid(@Param("pfteamid") Serializable pfteamid) ;

}
